package postgresql

import (
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

func TestPG(t *testing.T) {
	m := NewMatcher()

	conn, err := net.Dial("tcp", "192.168.1.229:5432")
	if err != nil {
		t.Error(err)
		return
	}
	defer conn.Close()

	matchCtx := osm.NewMatchCtx("192.168.1.229", 5432)

	for i := 0; i < m.PacketCount(matchCtx); i++ {

		pack := m.Packet(matchCtx, i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := osm.NewPacket(bytes, n)

		if err := m.Match(nil, i, p); err != nil {
			t.Error(err)
		}
	}
	t.Log(m.Name(matchCtx))
	t.Log(matchCtx)
}
